@echo off
SETLOCAL ENABLEDELAYEDEXPANSION


echo ">" Removal of non-present (ghosted,hidden) devices on virtual machine - VM

md %COMPUTERNAME%

set devcon_v= %COMPUTERNAME%\%COMPUTERNAME%-all-DevconFind-V.txt
set devcon_p= %COMPUTERNAME%\%COMPUTERNAME%-present-DevconFind-V.txt
set devcon_r= %COMPUTERNAME%\%COMPUTERNAME%-removed-DevconFind-V.txt


echo. > %devcon_r%


echo ... Searching all devices : devcon findall
DEVCON Findall * | FIND /I /V "matching device(s)" | find /v "RAS Async Adapter" > %devcon_v%

echo ... Saving to %devcon_v%




echo ... Searching all present devices : devcon find
DEVCON Find * | FIND /I /V "matching device(s)" > %devcon_p%

echo ... Saving to %devcon_p%



echo ... Searching non-present devices : [devcon findall - devcon find]

FOR /F "tokens=1* delims=: " %%A  IN ( %devcon_v%) DO (

	type %devcon_p% | find  "%%~A" >NUL

	IF ERRORLEVEL 1 (
		
		rem    Found one that's not in present list  but it could be in a desactived , inactif state or just a service (non pnp device)

		devcon status "@%%~A" | find /v "tching de" | find /i /v "name:"  | find /v "\" > temp.txt

		dir temp.txt | find /i  "0 temp.txt" >NUL

		IF  ERRORLEVEL 1 (

			rem  Temp.txt is not empty, the device is not running or not enabled or ... but it's there !

		) ELSE (

			rem  The device can be sofware device (a non pnp device) we need to check about it. 
			
			echo "%%~A" | find "LEGACY" >NUL
			IF ERRORLEVEL 1 (
				rem	OK it's a hardware device, we found one to delete :)
				devcon status "@%%~A" | find /i /v "matching device(s)" >> %devcon_r%
				devcon remove "@%%~A" 


			) ELSE (
				rem   ko  it's service (root\legacy) , get only the legacy_XXX part and call :servicecheck
			
				for /f "tokens=2 delims=^\" %%B in ("%%~A") DO ( CALL :servicecheck %%~B)
					

			
			)

			 
		)
	)


)

goto fin




:servicecheck


		rem We are reducing service name : legacy_XXXX to XXXX
		set devconlegacy=%1
		set devcon_service=%devconlegacy:LEGACY_=%

		rem check service existance
		set servicename=ROOT^\LEGACY_%devcon_service%^\0000
		SC getdisplayname  %devcon_service% | FIND "FAILED 1060">NUL
		IF ERRORLEVEL 1 (
			rem   service is there
		) ELSE (
			rem OK found a failed serive BUT we still need to check AGAIN.  some service don't use XXXX for the service name (some 10 percent of them) !


			rem get their true name
			for /F  "tokens=2* delims=:" %%X  in ( 'devcon status  "@%servicename%" ^| find /i "name"' ) DO (
				CALL :truename "%%~X" "%servicename%" %1

			)
			
		)


GOTO :eof


:truename
	set servicenametemp=%~1
	set servicenametemp2=%servicenametemp:~1%
	sc getkeyname "%servicenametemp2%" | find "FAILED">NUL
	if errorlevel 1 (
		rem no prob
	) else (
		echo %~2 >> %devcon_r%
		echo	Name: "%servicenametemp2%" >> %devcon_r%

		devcon remove "@%~2"

	)
GOTO :eof




:fin
echo ..Finished
notepad %devcon_r%
pause			

